<?php
/***************************************************************************
                                  Abstract1.php
                               -------------------
  
       A PHP5 class used as a reference to test abstract class parsing. 

 **************************************************************************/
 
/**
 * A class for abstract parsing tests.
 *
 * @author    JM Faure <jmfaure@users.sourceforge.net>
 * @version   1.0
 * @date      09 Aug 2005
 */
abstract class Abstract1 {

/**
 * Integer counter.
 *
 * For your information, properties cannot be declared abstract in PHP5.
 */
public $count = 1;

/**
 * A method with 3 parameters.
 *
 * Force extending class to define this method.
 *
 * @experimental
 * @param (string) $p1 the first parameter
 * @param (int) $p2 the second parameter
 * @param (bool) $p3 the 3rd parameter
 * @return (void)
 */
abstract protected function m3param($p1, int $p2, $p3 = true);

/**
 * A method with parameters passed by reference.
 *
 * The function statement presents the & reference char in
 * different places (& $p1 and &$p2).
 *
 * @warning  unstable
 * @param (string) $p1 the 1st parameter
 * @param (bool) $p2 the 2nd parameter
 *                   has a two-line comment
 * @return (string) the function result
 */
private function mpbyref(& $p1, bool &$p2) {

  return $p1;
}

/**
 * A method with a lot @info items.
 *
 * The function statement presents default values and casting.
 *
 * @warning  unstable
 * @forfun   a dummy comment on two lines to test 
 *           @info parsing
 * @param (int) $p1 the first parameter
 * @param (mixed) $p2 a text (string) as regular entry
 *                    or false (bool) to get a particualr behavior
 * @param (string) $p3 the third parameter
 *                  is commented onto
 *                  three lines
 * @param (array) $p4 a structured list:
 *                    'name' => the user name
 *                    'address' => the user address
 *                    'city' => the city name
 * @return (void) if echo flag $p1 is true,
 *                the comment continue on a three
 *                lines to test return values parsing
 *         (string) the printable result if echo flag is false (default)
 */
protected function mlotinf($p1, $p2="a string", string $p3 = "another string", $p4) {

  if ($p1) {
    return;
  } else {
    return "whatever";
  }
}
}
?>
