<?php
/***************************************************************************
                                  Class5.php
                              -------------------
  
        A PHP5 class used as a reference to test properties parsing. 

 **************************************************************************/
 
/**
 * Class to test properties parsing.
 *
 * This class presents a lot of property declaration statements to test
 * most of parsing possibilities.
 */
class Class5 {

/**
 * Integer property.
 *
 * The @type info is mandatory for property documenting.
 *
 * @type int
 */
private static $anint = 27;

/**
 * Protected and static integer property.
 *
 * This property has an initial value.
 *
 * @type int
 */
protected static $apsint = 0;

/**
 * Mixed property.
 *
 * The "type" comment is required so if 
 * property type isn't sure, use "mixed".
 *
 * @type mixed
 */
public $mixer;

/**
 * Private property.
 *
 * Not type is defined (not recommended).
 */
private $privob;

/**
 * Protected property.
 *
 * @type object
 */
protected $protob;

/**
 * Simplest code documenting property.
 */
protected $simpob;

/** 
 * Stack of XHTML formated output string.
 *
 * This property has a "multiline" initial value.
 *
 * @type array
 */
public static $multi = array(
                         'next' => "<hr class=\"next\" />",
                         'nl' => "<br />",
                         'trap' => "<b>a ; to trap value parsing</b>",
                       );

/**
 * Constructor with PHP5 class syntax.
 *
 * Print an instance creation message.
 * 
 * @public
 * @return (object) an instance of this class (@return comment 
 *                  is mandatory for any member function)
 */
function __construct() {

  echo "A new instance has been created.";
}

/**
 * Very simple method.
 *
 * @return (void) 
 */
public function hello() {

  echo "Hello world!";
}
}
?>
