<?php
/***************************************************************************
                                  Class6.php
                              -------------------
  
        A PHP4 class used as a reference to test properties parsing. 

 **************************************************************************/
 
/**
 * Class to test properties parsing.
 *
 * This class presents a lot of property declaration statements to test
 * most of parsing possibilities.
 */
class Class6 {

/**
 * Integer property.
 *
 * This property has an initial value.
 *
 * @private
 * @type int
 */
var $anint = 27;

/**
 * Protected and static integer property.
 *
 * This property has an initial value.
 *
 * @protected
 * @type int
 */
var $apsint = 0;

/**
 * Mixed property.
 *
 * The "type" comment is required so if 
 * property type isn't sure, use "mixed".
 *
 * @type mixed
 */
var $mixer;

/**
 * Private property.
 *
 * @private
 * @type object
 */
var $privob;

/**
 * Protected property.
 *
 * @protected
 * @type object
 */
var $protob;

/** 
 * Stack of XHTML formated output string.
 *
 * This property has a "multiline" initial value.
 *
 * @type array
 */
var $multi = array(
               'next' => "<hr class=\"next\" />",
               'nl' => "<br />",
               'trap' => "<b>a ; to trap value parsing</b>",
             );

/**
 * Constructor with PHP5 class syntax.
 *
 * Print an instance creation message.
 * 
 * @public
 * @return (object) an instance of this class (@return comment 
 *                  is mandatory for any member function)
 */
function __construct() {

  echo "A new instance has been created.";
}

/**
 * Very simple method.
 *
 * @return (void) 
 */
function hello() {

  echo "Hello world!";
}
}
?>
